/*~******************************************************************************************
*	~Project:	"Alone"																		*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
*	~Purpose:	Common includes, defines and constants.										*
******************************************************************************************~*/

#ifndef _Alone_Alone_h_
#define _Alone_Alone_h_

#ifndef _DEBUG
  #define DEBUGTOOLSET_NO
  #define DTS_NOTIMPLEMENTED
#else
  #define DEBUGTOOLSET_FORCE
  #define DTS_NOTIMPLEMENTED  DTS_ASSERT(0 && "Not Yet Implemented");
#endif

#include <string>

#include <GameMath.h>
using namespace GameMath;

#include <DebugToolSet.h>
#include <InternalCombustion.h>
using namespace InternalCombustion;
using namespace InternalCombustion::Visual;
using namespace InternalCombustion::Audio;
using namespace InternalCombustion::Input;
using namespace InternalCombustion::System;
using namespace InternalCombustion::Timing;

#include "Utilities/Config.h"
#include "Utilities/CScript.h"
#include "Utilities/Camera2D.h"

#include "Helpers/CSprite.h"
#include "Helpers/CSpriteFont.h"

extern Config *TheConfig;

typedef unsigned long Millisec;
const Millisec SimulateTimeMS = 1;
const float SimulateTimeSec = SimulateTimeMS / 1000.0f;
const float SimulateDT = SimulateTimeSec;

const std::string& ToDataDir(void);
const std::string& ToUserDir(void);

enum FootballTeam
{
	TEAM_AWAY = 0,
	TEAM_HOME = 1,
};

namespace Textures
{
	extern iceTexture* FieldTiles;
	extern iceTexture* AwayPlayer;
	extern iceTexture* HomePlayer;
	extern iceTexture* HomeTeam;
	extern iceTexture* HeadsUpDisplay;
	extern iceTexture* SimpleFont;
	extern iceTexture* DustBall;
	extern iceTexture* Football;
};

namespace Sounds
{
	//void QueueVO(const std::string &vfx, int maxRand);
	void PlayVO(const std::string &vfx, int maxRand = -1);
	void PlaySfx(const std::string &vfx, int maxRand = -1);

	extern iceAudio* Music;
	extern iceAudio* Whistle;
	extern iceAudio* HikeBall;
};

namespace Rand
{
	void SetSeed(unsigned long seed);
	unsigned long Rand(void);
	float RandF(void);
	float RandF(float min, float max);
};

#endif _Alone_Alone_h_