/*~******************************************************************************************
*	~Project:	"Alone"																		*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
*	~Purpose:	Football field for some basic gameplay.										*
******************************************************************************************~*/

#ifndef _Alone_CFootball_h_
#define _Alone_CFootball_h_

#include "Alone.h"

static const float FootballSpeed = 5.0f;

class CFootballPlayer;
class CFootballField;

class CFootball : public CSpriteObject
{
private:
	Vector3 mTargetPos;
	bool mIsInAir;	
	CFootballPlayer *mPlayer;
	CFootballPlayer *mThrower;
	CFootballField *mFootballField;

public:

	CFootball(void);
	~CFootball(void);

	void Update(float dt);
	void ThrowTo(const Vector3 &pos);

	void SetFootballField(CFootballField *field) { mFootballField = field; }
	void SetPlayer(CFootballPlayer *plyrWithBall);
	CFootballPlayer* GetPlayer(void) { return mPlayer; }

	bool IsInAir(void) const { return mIsInAir; }
};

#endif _Alone_CFootball_h_