/*~******************************************************************************************
*	~Project:	"Alone"																		*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
******************************************************************************************~*/

#include "../Alone.h"
#include "CGamePlay.h"

#include "../CFootballField.h"
#include "../CFootballPlayer.h"

CFootballField *mFootballField = nullptr;
CGamePlay::~CGamePlay(void)
{

}

void CGamePlay::Simulate(void)
{

}

void CGamePlay::Update(float dt)
{
	mFootballField->Update(dt);
}

void CGamePlay::Render(void) const
{

}

void CGamePlay::Draw(void) const
{
	mFootballField->Draw();
}

bool CGamePlay::Load(IState *prevState)
{	
	mFootballField = new CFootballField();
	mFootballField->Reset4thQuarter(TheConfig->mGameTime * 1.0f, (unsigned char)TheConfig->mAwayPoints, 10);
	mFootballField->ResetForDown();

	TheAudioSystem->TestSound_Play(Sounds::Music, true);
	TheAudioSystem->TestSound_SetVolume(Sounds::Music, 0.78f);

	Camera::SetZoom(0.0625f);
	return true;
}

void CGamePlay::Unload(IState *nextState)
{
	if (nullptr != Sounds::Music)
		TheAudioSystem->TestSound_Stop(Sounds::Music);
	delete mFootballField;		mFootballField = nullptr;
}