/*~******************************************************************************************
*	~Project:	"Alone"													*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
******************************************************************************************~*/

#include "../Alone.h"
#include "CMainMenu.h"

CMainMenu::CMainMenu(void) : mMaxExitTimer(1.0f), mExitTimer(-1.0f), mTitleTexture(nullptr)
{

}

CMainMenu::~CMainMenu(void)
{

}



void CMainMenu::Simulate(void)
{

}

void CMainMenu::Update(float dt)
{
	if (TheInputSystem->IsKeyPressed(ICEKEY_SPACE) || TheInputSystem->IsKeyPressed(ICEKEY_ESCAPE))
	{
		if (mExitTimer < 0.0f)
			mExitTimer = mMaxExitTimer;
	}

	if (mExitTimer >= 0.0f)
	{
		mExitTimer -= dt;
		if (mExitTimer < 0.0f)
			TheStateMachine->ChangeToState("Tutorial");
	}	
}

void CMainMenu::Render(void) const
{

}

void CMainMenu::Draw(void) const
{
	float aspect = TheVisualSystem->GetAspectRatio();
	TheVisualSystem->Clear(0xFF39A533);

	float texSize = 0.85f;
	float texAspect = 512.0f / 232.0f;

	CSprite spr;
	spr.SetScreenCoords(0.5f * aspect, 0.5f, texSize, texSize);
	spr.CenterHotSpot();
	spr.SetColor(0xFF00CCFF);

	if (mExitTimer >= 0.0f)
	{
		unsigned long b = (unsigned long)((mExitTimer / mMaxExitTimer) * 256);
		unsigned long a = 0x00FFFFFF | (b << 24);
		spr.SetColor(spr.GetColor() & a);
	}

	TheVisualSystem->Texture_Bind(0, mTitleTexture);
	spr.Draw();
}

bool CMainMenu::Load(IState *prevState)
{
	TheVisualSystem->Texture_CreateFromFile(&mTitleTexture, ToDataDir() + "Helmet.png");
	return true;
}

void CMainMenu::Unload(IState *nextState)
{
	TheVisualSystem->Texture_Destroy(&mTitleTexture);		mTitleTexture = nullptr;
}