/*~******************************************************************************************
*	~Project:	"Alone"													*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
******************************************************************************************~*/

#include "../CStateMachine.h"

#ifndef _Alone_CMainMenu_h_
#define _Alone_CMainMenu_h_

class CMainMenu : public IState
{
private:
	float mExitTimer;
	float mMaxExitTimer;
	iceTexture *mTitleTexture;

public:
	CMainMenu(void);
	virtual ~CMainMenu(void);

	virtual std::string StateName(void) const { return "MainMenu"; }

	virtual void Simulate(void);
	virtual void Update(float dt);
	virtual void Render(void) const;
	virtual void Draw(void) const;

	virtual bool Load(IState *prevState);
	virtual void Unload(IState *nextState);
};

#endif _Alone_CMainMenu_h_