/*~******************************************************************************************
*	~Project:	"Alone"													*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
******************************************************************************************~*/

#include "../Alone.h"
#include "CSplashScreen.h"

CSplashScreen::CSplashScreen(void) : mExitTimer(-1.0f), mMaxExitTimer(1.0f),
	mLogoTexture(nullptr)
{

}

CSplashScreen::~CSplashScreen(void)
{

}

void CSplashScreen::Simulate(void)
{

}

void CSplashScreen::Update(float dt)
{
	if (TheInputSystem->IsKeyPressed(ICEKEY_SPACE) || TheInputSystem->IsKeyPressed(ICEKEY_ESCAPE))
	{
		if (mExitTimer < 0.0f)
			mExitTimer = mMaxExitTimer;
	}

	if (mExitTimer >= 0.0f)
	{
		mExitTimer -= dt;
		if (mExitTimer < 0.0f)
			TheStateMachine->ChangeToState("MainMenu");
	}	
}

void CSplashScreen::Render(void) const
{

}

void CSplashScreen::Draw(void) const
{
	float aspect = TheVisualSystem->GetAspectRatio();
	
	float texSize = 0.85f;
	float texAspect = 512.0f / 232.0f;

	CSprite spr;
	spr.SetScreenCoords(0.5f * aspect, 0.5f, texSize, texSize);
	spr.CenterHotSpot();
	spr.SetColor(0xFF00CCFF);

	if (mExitTimer >= 0.0f)
	{
		unsigned long b = (unsigned long)((mExitTimer / mMaxExitTimer) * 256);
		unsigned long a = 0x00FFFFFF | (b << 24);
		spr.SetColor(spr.GetColor() & a);
	}

	TheVisualSystem->Texture_Bind(0, mLogoTexture);
	spr.Draw();
}

bool CSplashScreen::Load(IState *prevState)
{
	TheVisualSystem->Texture_CreateFromFile(&mLogoTexture, ToDataDir() + "blackbird.png");
	return true;
}

void CSplashScreen::Unload(IState *nextState)
{
	TheVisualSystem->Texture_Destroy(&mLogoTexture);		mLogoTexture = nullptr;
}