/*~******************************************************************************************
*	~Project:	"Alone"													*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
******************************************************************************************~*/

#include "../CStateMachine.h"

#ifndef _Alone_CSplashScreen_h_
#define _Alone_CSplashScreen_h_

class CSplashScreen : public IState
{
private:
	float mExitTimer;
	float mMaxExitTimer;
	iceTexture *mLogoTexture;

public:
	CSplashScreen(void);
	virtual ~CSplashScreen(void);

	virtual std::string StateName(void) const { return "SplashScreen"; }

	virtual void Simulate(void);
	virtual void Update(float dt);
	virtual void Render(void) const;
	virtual void Draw(void) const;

	virtual bool Load(IState *prevState);
	virtual void Unload(IState *nextState);
};

#endif _Alone_CSplashScreen_h_