/*~******************************************************************************************
*	~Project:	"Alone"																		*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
******************************************************************************************~*/

#include "../CStateMachine.h"

#ifndef _Alone_CTutorial_h_
#define _Alone_CTutorial_h_

class CTutorial : public IState
{
private:
	float mExitTimer;
	float mMaxExitTimer;
	iceTexture *mTutorialTexture;

public:
	CTutorial(void);
	virtual ~CTutorial(void);

	virtual std::string StateName(void) const { return "Tutorial"; }

	virtual void Simulate(void);
	virtual void Update(float dt);
	virtual void Render(void) const;
	virtual void Draw(void) const;

	virtual bool Load(IState *prevState);
	virtual void Unload(IState *nextState);
};

#endif _Alone_CTutorial_h_