/*~**********************************************************************************************************************
*	~Project / File:	"iceHelpers" - "CSpriteFont.h"																	*
*																														*
*	~Author:			Tim Beaudet																						*
*	~Date Created:		10/2/2010																						*
*	~Last Updated:		10/2/2010																						*
*	~Version:			1.0.0																							*
*																														*
*	~Purpose:			Using the CSprite this will provide a simple interface for sprite based fonts.					*
*																														*
**********************************************************************************************************************~*/

#ifndef _iceHelpers_CSpriteFont_h_
#define _iceHelpers_CSpriteFont_h_

#include "../Alone.h"
#include "CSprite.h"

/*~**********************************
*      Forward Declarations		    *
**********************************~*/

class CSpriteFont
{
private:
	mutable CSprite mLetterSprites[256];	//Ascii Based Indices
	
public:
	/*~**********************************
	*      Constructors/Destructor      *
	**********************************~*/

	CSpriteFont(void);
	~CSpriteFont(void);

	/*~**********************************
	*       Methods and Functions       *
	**********************************~*/

	void Draw(float x, float y, float letterHeight, const char *szText) const;
	void DrawFmt(float x, float y, float letterHeight, const char *szTextFmt, ...) const;
	void DrawShadowed(float x, float y, float letterHeight, unsigned long shadowColor, const char *szText) const;
	void DrawShadowedFmt(float x, float y, float letterHeight, unsigned long shadowColor, const char *szTextFmt, ...) const;

	static float ComputeWidth(float letterHeight, const char *szText);
	static float ComputeWidthFmt(float letterHeight, const char *szTextFmt, ...);
	void SetColor(unsigned long color) const;

	/*~**********************************************************************************************************************
	*	~Function:			"MethodName"																					*
	*	~Modified By:		Tim Beaudet																						*
	*	~Last Updated:		3/27/2010																						*
	*																														*
	*	~Purpose:			TEMPLATE_TODO: Write something useful.															*
	*																														*
	*	~In:				Nothing.																						*
	*																														*
	*	~Out:				Nothing.																						*
	**********************************************************************************************************************~*/

	/*~**********************************
	*        Operator Overloads         *
	**********************************~*/

	/*~**********************************
	*      Accessors and Mutators       *
	**********************************~*/

	//void SetTextureCoords(float u, float v, float w, float h);
	//void SetScreenCoords(float x, float y, float w, float h);
	//void SetHotSpot(float x, float y);
	//void SetColor(unsigned long col);

	/*~**********************************
	*    Friend Classes and Methods     *
	**********************************~*/

	/*~**********************************
	*        Protected Interface        *
	**********************************~*/
protected:

	/*~**********************************
	*         Private Interface         *
	**********************************~*/
private:
	void Recompute(void) const;
};

#endif _iceHelpers_CSpriteFont_h_