/*~******************************************************************************************
*	~Project:	"TestProjects"																*
*	~Author:	Tim Beaudet																	*
*	~Modified:	09/25/2011																	*
******************************************************************************************~*/

#include "Camera2D.h"

using namespace GameMath;

namespace Camera
{

	Vector3 TheCamera(0.0f, 0.125f * 0.75f, 0.0f);
	bool PlaneXZ = true;

	void SetPlaneXZ(bool xzPlane)
	{
		if (xzPlane == PlaneXZ)
			return;

		PlaneXZ = xzPlane;
		float oldZoomOrOffset = TheCamera.y;
		TheCamera.y = TheCamera.z;
		TheCamera.z = oldZoomOrOffset;
	}

	bool GetPlaneXZ(void)
	{
		return PlaneXZ;
	}

	Vector3 GetPosition(void) 
	{ 
		Vector3 v = TheCamera; 
		v.y = 0.0f; 
		return v; 
	}

	void SetPosition(const GameMath::Vector3 &pos)
	{
		if (true == PlaneXZ)
		{
			TheCamera.x = pos.x;
			TheCamera.z = pos.z;
		}
		else	//PlaneXY
		{
			TheCamera.x = pos.x;
			TheCamera.y = pos.y;
		}
	}

	float GetZoom(void)
	{
		if (true == PlaneXZ)
			return TheCamera.y;
		return TheCamera.z;
	}

	void SetZoom(float zoom)
	{
		if (true == PlaneXZ)
			TheCamera.y = zoom;
		else
			TheCamera.z = zoom;
	}

	GameMath::Vector3* ToWorldSpace(GameMath::Vector3 *screenPos)
	{
		if (true == PlaneXZ)
		{
			screenPos->x = (screenPos->x / TheCamera.y) + TheCamera.x;
			screenPos->z = (screenPos->y / TheCamera.y) + TheCamera.z;
			screenPos->y = 0.0f;
			return screenPos;
		}

		screenPos->x = (screenPos->x / TheCamera.z) + TheCamera.x;
		screenPos->y = (screenPos->y / TheCamera.z) + TheCamera.y;
		screenPos->z = 0.0f;
		return screenPos;
	}

	GameMath::Vector3* ToScreenSpace(GameMath::Vector3 *worldPos)
	{
		if (true == PlaneXZ)
		{
			worldPos->x = (worldPos->x - TheCamera.x) * TheCamera.y;
			worldPos->y = (worldPos->z - TheCamera.z) * TheCamera.y;
			worldPos->z = 0.0f;
			return worldPos;
		}

		worldPos->x = (worldPos->x - TheCamera.x) * TheCamera.z;
		worldPos->y = (worldPos->y - TheCamera.y) * TheCamera.z;
		worldPos->z = 0.0f;
		return worldPos;
	}


	GameMath::Vector3* ToWorldScale(GameMath::Vector3 *screenPos)
	{
		if (true == PlaneXZ)
		{
			screenPos->x = (screenPos->x / TheCamera.y);
			screenPos->z = (screenPos->y / TheCamera.y);
			screenPos->y = 0.0f;
			return screenPos;
		}

		screenPos->x = (screenPos->x / TheCamera.z);
		screenPos->y = (screenPos->y / TheCamera.z);
		screenPos->z = 0.0f;
		return screenPos;
	}

	GameMath::Vector3* ToScreenScale(GameMath::Vector3 *worldPos)
	{	//Untested
		if (true == PlaneXZ)
		{
			worldPos->x = worldPos->x * TheCamera.y;
			worldPos->y = worldPos->z * TheCamera.y;
			worldPos->z = 0.0f;
			return worldPos;
		}

		worldPos->x = worldPos->x * TheCamera.z;
		worldPos->y = worldPos->y * TheCamera.z;
		worldPos->z = 0.0f;
		return worldPos;
	}

};	//namespace Camera