/*~******************************************************************************************
*	~Project:	"Alone"													*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
*	~Purpose:	Configuration / Options for the project.									*
******************************************************************************************~*/

#include "Config.h"
#include "CScript.h"

Config gRealConfig;
Config *TheConfig = &gRealConfig;

void Config::SetDefaultConfig(Config *cfg)
{
	cfg->mWindowWidth = 1024;	cfg->mWindowHeight = 768;
	cfg->mWindowPosX = 100;		cfg->mWindowPosY = 100;
	cfg->mFullScreen = false;
}

void Config::LoadConfigFromFile(Config *cfg, const std::string &strFilePath)
{
	SetDefaultConfig(cfg);
	Utilities::CScript *file = Utilities::OpenScriptFromFile(strFilePath);
	if (nullptr != file)
	{
		std::string token;
		while (false == file->EndOfFile())
		{
			token = file->Read();
			for (std::string::iterator itr = token.begin(), itrEnd = token.end(); itr != itrEnd; ++itr)
				*itr = tolower(*itr);

			if ("window" == token)
			{
				cfg->mWindowWidth = file->ReadAs<int>();
				cfg->mWindowHeight = file->ReadAs<int>();
				cfg->mWindowPosX = file->ReadAs<int>();
				cfg->mWindowPosY = file->ReadAs<int>();
				cfg->mFullScreen = file->ReadAs<bool>();
			}
			if ("awaypoints" == token)
				cfg->mAwayPoints = file->ReadAs<int>();
			if ("gametime" == token)
				cfg->mGameTime = file->ReadAs<int>();
		}

		Utilities::CloseScript(file);
	}
}

void Config::SaveConfigToFile(Config *cfg, const std::string &strFilePath)
{
	Utilities::CScript *file = Utilities::OpenScriptFromData("");
	if (nullptr != file)
	{
		file->Write("Window ");
		file->WriteAs(cfg->mWindowWidth);	file->WriteAs(' ');
		file->WriteAs(cfg->mWindowHeight);	file->WriteAs(' ');
		file->WriteAs(cfg->mWindowPosX);		file->WriteAs(' ');
		file->WriteAs(cfg->mWindowPosY);		file->WriteAs(' ');
		file->WriteAs(cfg->mFullScreen);		file->WriteAs('\n');

		file->Write("GameTime ");	file->WriteAs(cfg->mGameTime);	file->WriteAs('\n');
		file->Write("AwayPoints ");	file->WriteAs(cfg->mAwayPoints);		file->WriteAs('\n');

		file->SaveToFile(strFilePath);
		Utilities::CloseScript(file);
	}
}