/*~******************************************************************************************
*	~Project:	"Alone"													*
*	~Author:	Tim Beaudet																	*
*	~Modified:	12/16/2011																	*
*	~Purpose:	Configuration / Options for the project.									*
******************************************************************************************~*/

#ifndef _Alone_Config_h_
#define _Alone_Config_h_

#include <string>

struct Config
{
	long mWindowWidth;
	long mWindowHeight;
	long mWindowPosX;
	long mWindowPosY;
	bool mFullScreen;

	long mAwayPoints;
	long mGameTime;

	static void SetDefaultConfig(Config *cfg);
	static void LoadConfigFromFile(Config *cfg, const std::string &strFilePath);
	static void SaveConfigToFile(Config *cfg, const std::string &strFilePath);
};

extern Config *TheConfig;

#endif _Alone_Config_h_